#ifndef OGREVIEWER_H_INCLUDED
#define OGREVIEWER_H_INCLUDED

#include <vector>

#include "Ogre.h"
#include "OIS.h"

using namespace std;

class Robot
{
public:
    int id;         // jedinecne id robota
    bool alive;     // pokud m bt robot odstrann : alive=false
    bool visible;

    float poziceX;  // pozice X robota
    float poziceY;  // pozice Y robota

    float rotaceRobota;     // rotace oproti defaultni orientaci
    float rotaceKol;        // rotace kol oproti defaultni orientaci    Ogre::Entity *telo;

    Ogre::Entity *telo;
    Ogre::Entity *kola;
    Ogre::SceneNode *robotNode;
    Ogre::SceneNode *kolaNode;

    Robot(int ID);
};

// ZDE JSOU PROMENNE, KTERE POTREBUJE KAZDA APLIKACE OGRE
class PromenneOgre
{
protected:
    Ogre::Root *root;
    Ogre::ResourceGroupManager *resManager;
    Ogre::SceneManager *scena;

    Ogre::RenderWindow *window;
    Ogre::Viewport *viewport;

    OIS::InputManager *inputManager;
    OIS::Mouse *mys;
    OIS::Keyboard *klavesnice;
};

// ZDE JSOU PROMENNE POTREBNE K VYTVORENI 3D SCENY
class PromenneSceny
{
protected:
    Ogre::Camera *kamera;
    Ogre::SceneNode *kameraNode;
    Ogre::SceneNode *kameraOuterNode;
    Ogre::Light *slunce;
    Ogre::Entity *entitaPodlahy;
    Ogre::SceneNode *nodePodlahy;
};

class OgreViewer : protected PromenneOgre, protected PromenneSceny
{
    friend bool createRobot(OgreViewer *viewer, Robot *robot);

    Ogre::Entity *telo;
    Ogre::Entity *kola;
    Ogre::SceneNode *modelNode;
    Ogre::SceneNode *kolaNode;

    float rychlostRotace;
    float rychlostPosunu;

public:
    std::vector<Robot> roboti;

    // KONSTRUKTOR
    OgreViewer();

    // FUNKCE
    bool renderFrame();
};

#endif // OGREVIEWER_H_INCLUDED
